Index: /trunk/src/VBox/Additions/linux/installer/vboxadd.sh
===================================================================
--- /trunk/src/VBox/Additions/linux/installer/vboxadd.sh	(revision 30294)
+++ /trunk/src/VBox/Additions/linux/installer/vboxadd.sh	(revision 30295)
@@ -178,5 +178,5 @@
         fi
     fi
-    printf "\nThe headers for the current running kernel are not found. If the following\nmodule compilation fails then this could be the reason.\n"
+    printf "\nThe headers for the current running kernel were not found. If the following\nmodule compilation fails then this could be the reason.\n"
     if [ "$system" = "redhat" ]; then
         printf "The missing package can be probably installed with\nyum install kernel-devel-$KERN_VER\n"
@@ -348,19 +348,26 @@
     if ! sh /usr/share/$PACKAGE/test/build_in_tmp \
         --no-dkms --no-print-directory > $LOG 2>&1; then
-        fail "`printf "Your system does not seem to be set up to build kernel modules.\nLook at $LOG to find out what went wrong"`"
+        fail_msg
+        printf "Your system does not seem to be set up to build kernel modules.\nLook at $LOG to find out what went wrong.  Once you have corrected it, you can\nrun\n\n  /etc/init.d/vboxadd setup\n\nto build them."
+        BUILDVBOXGUEST=""
+        BUILDVBOXSF=""
+        BUILDVBOXVIDEO=""
+    else
+        if ! sh /usr/share/$PACKAGE/test_drm/build_in_tmp \
+            --no-dkms --no-print-directory >> $LOG 2>&1; then
+            printf "\nYour guest system does not seem to have sufficient OpenGL support to enable\naccelerated 3D effects (this requires Linux 2.6.27 or later in the guest\nsystem).  This Guest Additions feature will be disabled.\n\n"
+            BUILDVBOXVIDEO=""
+        fi
     fi
     echo
-    if ! sh /usr/share/$PACKAGE/test_drm/build_in_tmp \
-        --no-dkms --no-print-directory >> $LOG 2>&1; then
-        printf "\nYour guest system does not seem to have sufficient OpenGL support to enable\naccelerated 3D effects (this requires Linux 2.6.27 or later in the guest\nsystem).  This Guest Additions feature will be disabled.\n\n"
-        BUILDVBOXVIDEO=""
-    fi
-    begin "Building the main Guest Additions module"
-    if ! $BUILDVBOXGUEST \
-        --save-module-symvers /tmp/vboxguest-Module.symvers \
-        --no-print-directory install >> $LOG 2>&1; then
-        fail "Look at $LOG to find out what went wrong"
-    fi
-    succ_msg
+    if [ -n "$BUILDVBOXGUEST" ]; then
+        begin "Building the main Guest Additions module"
+        if ! $BUILDVBOXGUEST \
+            --save-module-symvers /tmp/vboxguest-Module.symvers \
+            --no-print-directory install >> $LOG 2>&1; then
+            fail "Look at $LOG to find out what went wrong"
+        fi
+        succ_msg
+    fi
     if [ -n "$BUILDVBOXSF" ]; then
         begin "Building the shared folder support module"
@@ -424,8 +431,10 @@
 
     succ_msg
-    if running_vboxguest || running_vboxadd; then
-        printf "You should restart your guest to make sure the new modules are actually used\n\n"
-    else
-        start
+    if [ -n "$BUILDVBOXGUEST" ]; then
+        if running_vboxguest || running_vboxadd; then
+            printf "You should restart your guest to make sure the new modules are actually used\n\n"
+        else
+            start
+        fi
     fi
 }
